#include "car.h"
#include <iostream>
#include <cstring>
#include <algorithm>
using namespace std;


//	Понеже Person няма конструктор по подразбиране,
//	трябва да се инициализира явно.
Car :: Car(const char* brand, const char* model)
	:owner(DEFAULT_OWNER) {
	copyString(this->brand, brand, BRAND_NAME_LENGTH);
	copyString(this->model, model, MODEL_NAME_LENGTH);
	setNumber("");
}

void Car :: setOwner(const Person& owner) {
	this->owner = owner;
}

void Car :: setNumber(const char* number) {
	copyString(this->number, number, CAR_NUMBER_LENGTH);
}

void Car :: print() const {
	cout << brand << " " << model << " "
		<< number[0] << number[1] << " "
		<< number[2] << number[3]
		<< number[4] << number[5] << " "
		<< number[6] << number[7]
		<< " owned by ";
	owner.print();
}

void Car :: copyString(char* to, const char* from, unsigned long limit) {
	int size = min(strlen(from) + 1, limit);
	strncpy(to, from, size);
	to[size - 1] = '\0';
}
